# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.2.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _variable
else:
    import _variable

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import libcellml.namedentity
import libcellml.parentedentity
import libcellml.entity
import libcellml.types

# libCellML generated wrapper code starts here.

class Variable(libcellml.namedentity.NamedEntity):
    r"""Represents a CellML Variable entity"""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _variable.delete_Variable
    InterfaceType_NONE = _variable.Variable_InterfaceType_NONE
    InterfaceType_PRIVATE = _variable.Variable_InterfaceType_PRIVATE
    InterfaceType_PUBLIC = _variable.Variable_InterfaceType_PUBLIC
    InterfaceType_PUBLIC_AND_PRIVATE = _variable.Variable_InterfaceType_PUBLIC_AND_PRIVATE

    @staticmethod
    def addEquivalence(*args):
        r"""
        Adds an equivalence relation between this variable and the given one (both
        objects are updated)
        """
        return _variable.Variable_addEquivalence(*args)

    @staticmethod
    def setEquivalenceMappingId(variable1, variable2, mappingId):
        r"""
        Record the given identifier as the mapping identifier for the equivalence defined with the given
        variables.  The variables are commutative. This identifier appears in the 'map_variables'
        element of the model when serialised.

        To clear an equivalence mapping identifier set it to the empty string. If the two variables are
        not equivalent the mapping identifier is not set.
        """
        return _variable.Variable_setEquivalenceMappingId(variable1, variable2, mappingId)

    @staticmethod
    def setEquivalenceConnectionId(variable1, variable2, connectionId):
        r"""
        Record the given identifier as the connection identifier for the equivalence defined with the given
        variables.  The variables are commutative. This identifier appears in the 'connection'
        element of the model when serialised.

        To clear an equivalence connection identifier set it to the empty string. If the two variables are
        not equivalent the connection identifier is not set.
        """
        return _variable.Variable_setEquivalenceConnectionId(variable1, variable2, connectionId)

    @staticmethod
    def equivalenceMappingId(variable1, variable2):
        r"""Get the mapping identifier set for the equivalence defined with the given variables."""
        return _variable.Variable_equivalenceMappingId(variable1, variable2)

    @staticmethod
    def equivalenceConnectionId(variable1, variable2):
        r"""Get the connection identifier set for the equivalence defined with the given variables."""
        return _variable.Variable_equivalenceConnectionId(variable1, variable2)

    @staticmethod
    def removeEquivalenceConnectionId(variable1, variable2):
        r"""Remove the connection identifier for the equivalence defined with the given variables."""
        return _variable.Variable_removeEquivalenceConnectionId(variable1, variable2)

    @staticmethod
    def removeEquivalenceMappingId(variable1, variable2):
        r"""Remove the mapping identifier for the equivalence defined with the given variables."""
        return _variable.Variable_removeEquivalenceMappingId(variable1, variable2)

    @staticmethod
    def removeEquivalence(variable1, variable2):
        r"""
        Removes an equivalence between this variable and the given one (both objects
        are updated).

        Returns `True` on success.
        """
        return _variable.Variable_removeEquivalence(variable1, variable2)

    def removeAllEquivalences(self):
        r"""
        Removes all equivalent variables for this variable (all relevant objects are
        updated).
        """
        return _variable.Variable_removeAllEquivalences(self)

    def equivalentVariableCount(self):
        r"""Returns the number of equivalent variables for this variable."""
        return _variable.Variable_equivalentVariableCount(self)

    def hasEquivalentVariable(self, equivalentVariable, considerIndirectEquivalences=False):
        r"""
        Tests if the given variable is in this variable's set of equivalent
        variables.
        """
        return _variable.Variable_hasEquivalentVariable(self, equivalentVariable, considerIndirectEquivalences)

    def setUnits(self, *args):
        r"""Sets the units for this variable to the given string (name) or Units object."""
        return _variable.Variable_setUnits(self, *args)

    def units(self):
        r"""Returns the name of the units set for this variable (empty string if none)"""
        return _variable.Variable_units(self)

    def removeUnits(self):
        r"""Clears the units for this variable."""
        return _variable.Variable_removeUnits(self)

    def setInitialValue(self, *args):
        r"""
        Sets this variable's initial value, given as a string, number, or variable
        reference.
        """
        return _variable.Variable_setInitialValue(self, *args)

    def initialValue(self):
        r"""Returns the string corresponding to the initial value for this variable."""
        return _variable.Variable_initialValue(self)

    def removeInitialValue(self):
        r"""Clears the initial value for this variable."""
        return _variable.Variable_removeInitialValue(self)

    def setInterfaceType(self, *args):
        r"""
        Sets this variable's interfacetype to the given type specified as string or
        InterfaceType.
        """
        return _variable.Variable_setInterfaceType(self, *args)

    def interfaceType(self):
        r"""Returns this variable's interface type as a string."""
        return _variable.Variable_interfaceType(self)

    def removeInterfaceType(self):
        r"""Clears the interface type for this variable."""
        return _variable.Variable_removeInterfaceType(self)

    def hasInterfaceType(self, interfaceType):
        r"""Tests if this variable has the given interface type."""
        return _variable.Variable_hasInterfaceType(self, interfaceType)

    def permitsInterfaceType(self, interfaceType):
        r"""Tests if this variable will accept access through the given interface type."""
        return _variable.Variable_permitsInterfaceType(self, interfaceType)

    def clone(self):
        r"""Create a copy of this variable."""
        return _variable.Variable_clone(self)

    def equivalentVariable(self, *args):
        r"""Returns the equivalent variable at the given index."""
        return _variable.Variable_equivalentVariable(self, *args)

    def __init__(self, *args):
        _variable.Variable_swiginit(self, _variable.new_Variable(*args))

# Register Variable in _variable:
_variable.Variable_swigregister(Variable)

def Variable_addEquivalence(*args):
    r"""
    Adds an equivalence relation between this variable and the given one (both
    objects are updated)
    """
    return _variable.Variable_addEquivalence(*args)

def Variable_setEquivalenceMappingId(variable1, variable2, mappingId):
    r"""
    Record the given identifier as the mapping identifier for the equivalence defined with the given
    variables.  The variables are commutative. This identifier appears in the 'map_variables'
    element of the model when serialised.

    To clear an equivalence mapping identifier set it to the empty string. If the two variables are
    not equivalent the mapping identifier is not set.
    """
    return _variable.Variable_setEquivalenceMappingId(variable1, variable2, mappingId)

def Variable_setEquivalenceConnectionId(variable1, variable2, connectionId):
    r"""
    Record the given identifier as the connection identifier for the equivalence defined with the given
    variables.  The variables are commutative. This identifier appears in the 'connection'
    element of the model when serialised.

    To clear an equivalence connection identifier set it to the empty string. If the two variables are
    not equivalent the connection identifier is not set.
    """
    return _variable.Variable_setEquivalenceConnectionId(variable1, variable2, connectionId)

def Variable_equivalenceMappingId(variable1, variable2):
    r"""Get the mapping identifier set for the equivalence defined with the given variables."""
    return _variable.Variable_equivalenceMappingId(variable1, variable2)

def Variable_equivalenceConnectionId(variable1, variable2):
    r"""Get the connection identifier set for the equivalence defined with the given variables."""
    return _variable.Variable_equivalenceConnectionId(variable1, variable2)

def Variable_removeEquivalenceConnectionId(variable1, variable2):
    r"""Remove the connection identifier for the equivalence defined with the given variables."""
    return _variable.Variable_removeEquivalenceConnectionId(variable1, variable2)

def Variable_removeEquivalenceMappingId(variable1, variable2):
    r"""Remove the mapping identifier for the equivalence defined with the given variables."""
    return _variable.Variable_removeEquivalenceMappingId(variable1, variable2)

def Variable_removeEquivalence(variable1, variable2):
    r"""
    Removes an equivalence between this variable and the given one (both objects
    are updated).

    Returns `True` on success.
    """
    return _variable.Variable_removeEquivalence(variable1, variable2)


